package com.gzlh.device.plc.client;

import cn.hutool.extra.spring.SpringUtil;
import com.gzlh.bus.EventConfig;
import com.gzlh.config.SystemObject;
import com.gzlh.config.dto.SerialSetting;
import com.gzlh.device.plc.handler.PLCHadnler;
import com.gzlh.device.plc.service.PLCService;
import com.gzlh.utils.DeviceCache;
import com.gzlh.utils.ModbusUtils;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.lang.reflect.Field;
import java.util.*;

@Slf4j
@ChannelHandler.Sharable
public class PlcClientHandler extends SimpleChannelInboundHandler<String> {

    private PlcNettyConfig ledNettyConfig;

    @Autowired
    private PLCHadnler plcHadnler;

    public PlcClientHandler(PlcNettyConfig ledNettyConfig) {
        this.ledNettyConfig = ledNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        log.info("PLC 客户端收到消息：" + msg);

//        String crc = msg.substring(msg.length() - 4 );
        String data = msg.substring(0, msg.length() - 4);
        String str = ModbusUtils.buildRequestPacket(data);
        if (msg.equalsIgnoreCase(str)){
            plcHadnler.handlerMsg(msg);
        }



    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("PLC 客户端 连接断开，进行重连");
        ledNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

